org.apache.cassandra.cql3.statements

## Class CreateTableStatement

- java.lang.Object
- - org.apache.cassandra.cql3.statements.ParsedStatement
  - - org.apache.cassandra.cql3.statements.CFStatement
    - - org.apache.cassandra.cql3.statements.SchemaAlteringStatement
      - - org.apache.cassandra.cql3.statements.CreateTableStatement

All Implemented Interfaces:
  CQLStatement

    public class CreateTableStatement
    extends SchemaAlteringStatement

A `CREATE TABLE` parsed from a CQL query statement.

### Nested Class Summary

Nested Classes
`static class` `CreateTableStatement.RawStatement`

### Nested classes/interfaces inherited from class org.apache.cassandra.cql3.statements.ParsedStatement

`ParsedStatement.Prepared`

### Field Summary

### Fields inherited from class org.apache.cassandra.cql3.statements.CFStatement

`cfName`

### Constructor Summary

Constructors
Constructor and Description
`CreateTableStatement(CFName name, TableParams params, boolean ifNotExists, java.util.Set<ColumnIdentifier> staticColumns, java.util.UUID id)`

### Method Summary

All Methods Instance Methods Concrete Methods
`Event.SchemaChange` `announceMigration(QueryState queryState, boolean isLocalOnly)` Announces the migration to other nodes in the cluster.
`void` `checkAccess(ClientState state)` Perform any access verification necessary for the statement.
`CFMetaData` `getCFMetaData()` Returns a CFMetaData instance based on the parameters parsed from this `CREATE` statement, or defaults where applicable.
`protected void` `grantPermissionsToCreator(QueryState state)` Schema alteration may result in a new database object (keyspace, table, role, function) being created capable of having permissions GRANTed on it.
`CFMetaData.Builder` `metadataBuilder()`
`TableParams` `params()`
`void` `validate(ClientState state)` Perform additional validation required by the statment.

### Methods inherited from class org.apache.cassandra.cql3.statements.SchemaAlteringStatement

`execute, executeInternal, getBoundTerms, prepare, prepareKeyspace`

### Methods inherited from class org.apache.cassandra.cql3.statements.CFStatement

`columnFamily, keyspace, prepareKeyspace`

### Methods inherited from class org.apache.cassandra.cql3.statements.ParsedStatement

`getBoundVariables, getFunctions, setBoundVariables, setBoundVariables`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.cassandra.cql3.CQLStatement

`getFunctions`

### Constructor Detail

#### CreateTableStatement

    public CreateTableStatement(CFName name,
                                TableParams params,
                                boolean ifNotExists,
                                java.util.Set<ColumnIdentifier> staticColumns,
                                java.util.UUID id)

### Method Detail

#### checkAccess

    public void checkAccess(ClientState state)
                     throws UnauthorizedException,
                            InvalidRequestException

Description copied from interface: `CQLStatement`
Perform any access verification necessary for the statement.

Parameters:
  `state` - the current client state
Throws:
  `UnauthorizedException`
  `InvalidRequestException`

#### validate

    public void validate(ClientState state)

Description copied from interface: `CQLStatement`
Perform additional validation required by the statment. To be overriden by subclasses if needed.

Parameters:
  `state` - the current client state

#### announceMigration

    public Event.SchemaChange announceMigration(QueryState queryState,
                                                boolean isLocalOnly)
                                         throws RequestValidationException

Description copied from class: `SchemaAlteringStatement`
Announces the migration to other nodes in the cluster.

Specified by:
  `announceMigration` in class `SchemaAlteringStatement`
Returns:
  the schema change event corresponding to the execution of this statement, or `null` if no schema change has occurred (when IF NOT EXISTS is used, for example)
Throws:
  `RequestValidationException`

#### grantPermissionsToCreator

    protected void grantPermissionsToCreator(QueryState state)

Description copied from class: `SchemaAlteringStatement`
Schema alteration may result in a new database object (keyspace, table, role, function) being created capable of having permissions GRANTed on it. The creator of the object (the primary role assigned to the AuthenticatedUser performing the operation) is automatically granted ALL applicable permissions on the object. This is a hook for subclasses to override in order to perform that grant when the statement is executed.

Overrides:
  `grantPermissionsToCreator` in class `SchemaAlteringStatement`

#### metadataBuilder

    public CFMetaData.Builder metadataBuilder()

#### getCFMetaData

    public CFMetaData getCFMetaData()

Returns a CFMetaData instance based on the parameters parsed from this `CREATE` statement, or defaults where applicable.

Returns:
  a CFMetaData instance corresponding to the values parsed from this statement
Throws:
  `InvalidRequestException` - on failure to validate parsed parameters

#### params

    public TableParams params()